C.Mahmoud and a Message

Mahmoud and a Message

题目链接: Codeforces Round #396 (Div. 2) C. Mahmoud and a Message

题目描述

Mahmoud wrote a message s of length n. He wants to send it as a birthday present to his friend Moaz who likes strings. He wrote it on a magical paper but he was surprised because some characters disappeared while writing the string. That's because this magical paper doesn't allow character number i in the English alphabet to be written on it in a string of length more than ai. For example, if a1 = 2 he can't write character 'a' on this paper in a string of length 3 or more. String "aa" is allowed while string "aaa" is not.

Mahmoud decided to split the message into some non-empty substrings so that he can write every substring on an independent magical paper and fulfill the condition. The sum of their lengths should be n and they shouldn't overlap. For example, if a1 = 2 and he wants to send string "aaa", he can split it into "a" and "aa" and use 2 magical papers, or into "a", "a" and "a" and use 3 magical papers. He can't split it into "aa" and "aa" because the sum of their lengths is greater than n. He can split the message into single string if it fulfills the conditions.

A substring of string s is a string that consists of some consecutive characters from string s, strings "ab", "abc" and "b" are substrings of string "abc", while strings "acb" and "ac" are not. Any string is a substring of itself.

While Mahmoud was thinking of how to split the message, Ehab told him that there are many ways to split it. After that Mahmoud asked you three questions:

  • How many ways are there to split the string into substrings such that every substring fulfills the condition of the magical paper, the sum of their lengths is n and they don't overlap? Compute the answer modulo 109 + 7.
  • What is the maximum length of a substring that can appear in some valid splitting?
  • What is the minimum number of substrings the message can be spit in?

Two ways are considered different, if the sets of split positions differ. For example, splitting "aa|a" and "a|aa" are considered different splittings of message "aaa".

Input

The first line contains an integer n (1 ≤ n ≤ 103) denoting the length of the message.

The second line contains the message s of length n that consists of lowercase English letters.

The third line contains 26 integers a1, a2, ..., a26 (1 ≤ ax ≤ 103) — the maximum lengths of substring each letter can appear in.

Output

Print three lines.

In the first line print the number of ways to split the message into substrings and fulfill the conditions mentioned in the problem modulo 109  +  7.

In the second line print the length of the longest substring over all the ways.

In the third line print the minimum number of substrings over all the ways.

Examples

input1

3
aab
2 3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1

output1

3
2
2

input2

10
abcdeabcde
5 5 5 5 4 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1

output2

401
4
3

Note

In the first example the three ways to split the message are:

  • a | a | b
  • aa | b
  • a | ab

The longest substrings are "aa" and "ab" of length 2.

The minimum number of substrings is 2 in "a|ab" or "aa|b".

Notice that "aab" is not a possible splitting because the letter 'a' appears in a substring of length 3, while a1 = 2.

题目大意

给你一个长度为n且只含小写字母的字符串,然后让你把这个字符串分割成若干个子串。
每个小写字母都有一个数字ai,表示这个字母能够存在于长度不超过ai的字符串内。

解题思路

运用动态规划求解。
dp[i]表示字符串长度为i时分割情况数,从位置i往前取长度为j的子串,判断是否满足条件,然后不断更新结果即可。dp[n]即最终答案。
另外再开一个数组用来记录最少分割次数。cnt[i] = min(cnt[i],cnt[i-j]+1)。

代码

#include<cstdio>
#include<algorithm>
using namespace std;
#define MAXN 1005
#define MOD 1000000007

char s[MAXN];
int a[150], cnt[MAXN];
long long dp[MAXN];

int main(void)
{
    int n; scanf("%d",&n);
    scanf("%s",s+1);
    for(char c='a';c<='z';c=c+1) scanf("%d",&a[c]);
    int maxLen = 0;     //记录最大子串长度
    dp[0] = 1;
    for(int i=1;i<=n;++i){
        cnt[i] = MAXN;
        int minl = a[s[i]];     //字母能存在的最大长度,取该子串字母中的最小值
        for(int j=1; j<=minl; ++j){
            dp[i] += dp[i-j]; dp[i] %= MOD;
            maxLen = max(maxLen,j);
            cnt[i] = min(cnt[i],cnt[i-j]+1);
            minl = min(minl,a[s[i-j]]);     //更新能存在的最大长度
        }
    }
    printf("%lld
%d
%d
",dp[n],maxLen,cnt[n]);
    return 0;
}
海到无边天作岸,山登绝顶我为峰
原文地址:https://www.cnblogs.com/Fiona0726/p/12797509.html